// Code generated by go-swagger; DO NOT EDIT.

package data

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/validate"

	"code.fbi.h-da.de/cocsn/cocsn-api/api/models"
)

// NewDataCocsnInterfacesInterfaceInterfaceNamePutParams creates a new DataCocsnInterfacesInterfaceInterfaceNamePutParams object
// with the default values initialized.
func NewDataCocsnInterfacesInterfaceInterfaceNamePutParams() DataCocsnInterfacesInterfaceInterfaceNamePutParams {

	var (
		// initialize parameters with default values

		insertDefault = string("first")
	)

	return DataCocsnInterfacesInterfaceInterfaceNamePutParams{
		Insert: &insertDefault,
	}
}

// DataCocsnInterfacesInterfaceInterfaceNamePutParams contains all the bound params for the data cocsn interfaces interface interface name put operation
// typically these are obtained from a http.Request
//
// swagger:parameters data_cocsn_interfaces_interface_interface_name_put
type DataCocsnInterfacesInterfaceInterfaceNamePutParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*controlling the order when adding new list elements
	  In: query
	  Default: "first"
	*/
	Insert *string
	/*
	  Required: true
	  In: body
	*/
	Interface *models.DataCocsnInterfacesInterfaceInterfaceName
	/*Interface name. Example value: en0
	  Required: true
	  In: path
	*/
	InterfaceName string
	/*used to specify the insertion point
	  In: query
	*/
	Point *string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewDataCocsnInterfacesInterfaceInterfaceNamePutParams() beforehand.
func (o *DataCocsnInterfacesInterfaceInterfaceNamePutParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qInsert, qhkInsert, _ := qs.GetOK("insert")
	if err := o.bindInsert(qInsert, qhkInsert, route.Formats); err != nil {
		res = append(res, err)
	}

	if runtime.HasBody(r) {
		defer r.Body.Close()
		var body models.DataCocsnInterfacesInterfaceInterfaceName
		if err := route.Consumer.Consume(r.Body, &body); err != nil {
			if err == io.EOF {
				res = append(res, errors.Required("interface", "body", ""))
			} else {
				res = append(res, errors.NewParseError("interface", "body", "", err))
			}
		} else {
			// validate body object
			if err := body.Validate(route.Formats); err != nil {
				res = append(res, err)
			}

			if len(res) == 0 {
				o.Interface = &body
			}
		}
	} else {
		res = append(res, errors.Required("interface", "body", ""))
	}
	rInterfaceName, rhkInterfaceName, _ := route.Params.GetOK("interface-name")
	if err := o.bindInterfaceName(rInterfaceName, rhkInterfaceName, route.Formats); err != nil {
		res = append(res, err)
	}

	qPoint, qhkPoint, _ := qs.GetOK("point")
	if err := o.bindPoint(qPoint, qhkPoint, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindInsert binds and validates parameter Insert from query.
func (o *DataCocsnInterfacesInterfaceInterfaceNamePutParams) bindInsert(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		// Default values have been previously initialized by NewDataCocsnInterfacesInterfaceInterfaceNamePutParams()
		return nil
	}

	o.Insert = &raw

	if err := o.validateInsert(formats); err != nil {
		return err
	}

	return nil
}

// validateInsert carries on validations for parameter Insert
func (o *DataCocsnInterfacesInterfaceInterfaceNamePutParams) validateInsert(formats strfmt.Registry) error {

	if err := validate.EnumCase("insert", "query", *o.Insert, []interface{}{"first", "last", "before", "after"}, true); err != nil {
		return err
	}

	return nil
}

// bindInterfaceName binds and validates parameter InterfaceName from path.
func (o *DataCocsnInterfacesInterfaceInterfaceNamePutParams) bindInterfaceName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.InterfaceName = raw

	return nil
}

// bindPoint binds and validates parameter Point from query.
func (o *DataCocsnInterfacesInterfaceInterfaceNamePutParams) bindPoint(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	o.Point = &raw

	return nil
}
