// Code generated by go-swagger; DO NOT EDIT.

package data

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/validate"

	"code.fbi.h-da.de/cocsn/cocsn-api/api/models"
)

// NewDataCocsnRoutesRouteRouteDestinationPutParams creates a new DataCocsnRoutesRouteRouteDestinationPutParams object
// with the default values initialized.
func NewDataCocsnRoutesRouteRouteDestinationPutParams() DataCocsnRoutesRouteRouteDestinationPutParams {

	var (
		// initialize parameters with default values

		insertDefault = string("first")
	)

	return DataCocsnRoutesRouteRouteDestinationPutParams{
		Insert: &insertDefault,
	}
}

// DataCocsnRoutesRouteRouteDestinationPutParams contains all the bound params for the data cocsn routes route route destination put operation
// typically these are obtained from a http.Request
//
// swagger:parameters data_cocsn_routes_route_route_destination_put
type DataCocsnRoutesRouteRouteDestinationPutParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*controlling the order when adding new list elements
	  In: query
	  Default: "first"
	*/
	Insert *string
	/*used to specify the insertion point
	  In: query
	*/
	Point *string
	/*
	  Required: true
	  In: body
	*/
	Route *models.DataCocsnRoutesRouteRouteDestination
	/*Route destination. IP network
	  Required: true
	  In: path
	*/
	RouteDestination string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewDataCocsnRoutesRouteRouteDestinationPutParams() beforehand.
func (o *DataCocsnRoutesRouteRouteDestinationPutParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qInsert, qhkInsert, _ := qs.GetOK("insert")
	if err := o.bindInsert(qInsert, qhkInsert, route.Formats); err != nil {
		res = append(res, err)
	}

	qPoint, qhkPoint, _ := qs.GetOK("point")
	if err := o.bindPoint(qPoint, qhkPoint, route.Formats); err != nil {
		res = append(res, err)
	}

	if runtime.HasBody(r) {
		defer r.Body.Close()
		var body models.DataCocsnRoutesRouteRouteDestination
		if err := route.Consumer.Consume(r.Body, &body); err != nil {
			if err == io.EOF {
				res = append(res, errors.Required("route", "body", ""))
			} else {
				res = append(res, errors.NewParseError("route", "body", "", err))
			}
		} else {
			// validate body object
			if err := body.Validate(route.Formats); err != nil {
				res = append(res, err)
			}

			if len(res) == 0 {
				o.Route = &body
			}
		}
	} else {
		res = append(res, errors.Required("route", "body", ""))
	}
	rRouteDestination, rhkRouteDestination, _ := route.Params.GetOK("route-destination")
	if err := o.bindRouteDestination(rRouteDestination, rhkRouteDestination, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindInsert binds and validates parameter Insert from query.
func (o *DataCocsnRoutesRouteRouteDestinationPutParams) bindInsert(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		// Default values have been previously initialized by NewDataCocsnRoutesRouteRouteDestinationPutParams()
		return nil
	}

	o.Insert = &raw

	if err := o.validateInsert(formats); err != nil {
		return err
	}

	return nil
}

// validateInsert carries on validations for parameter Insert
func (o *DataCocsnRoutesRouteRouteDestinationPutParams) validateInsert(formats strfmt.Registry) error {

	if err := validate.EnumCase("insert", "query", *o.Insert, []interface{}{"first", "last", "before", "after"}, true); err != nil {
		return err
	}

	return nil
}

// bindPoint binds and validates parameter Point from query.
func (o *DataCocsnRoutesRouteRouteDestinationPutParams) bindPoint(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	o.Point = &raw

	return nil
}

// bindRouteDestination binds and validates parameter RouteDestination from path.
func (o *DataCocsnRoutesRouteRouteDestinationPutParams) bindRouteDestination(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.RouteDestination = raw

	return nil
}
